unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    PaintBox1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PaintBox1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

const size=100; //100
      csize=10; //10
      Colors:array[1..16] of TColor=             
      (clred,    clgreen,  clyellow,  clblue,
       clwhite,  clgray,   clfuchsia, clteal,
       clnavy,   clmaroon, cllime,    clolive,
       clpurple, clsilver, claqua,    clblack);

var
  Form1: TForm1;
  Points:array[1..size, 1..size] of integer;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var i,j:integer;
begin
randomize;
for i:=1 to size do
  for j:=1 to size do
    Points[i,j]:=1+random(csize);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  i,j:integer;
  c,l,r,u,d:integer;
  newPoints:array[1..size, 1..size] of integer;
begin
for i:=1 to size do
  for j:=1 to size do
    begin
      c:=points[i,j]+1;
      if c>csize then c:=1;
      u:=i-1;
      if u=0 then u:=size;
      d:=i+1;
      if d>size then d:=1;
      l:=j-1;
      if l=0 then l:=size;
      r:=j+1;
      if r>size then r:=1;
      newpoints[i,j]:=points[i,j];
      if (points[u,j]=c) or (points[d,j]=c) or (points[i,l]=c) or (points[i,r]=c) then
      newpoints[i,j]:=c;
    end;
c:=320 div size;
for i:=1 to size do
  for j:=1 to size do
    begin
      points[i,j]:=newpoints[i,j];
      Form1.PaintBox1.Canvas.Pen.Color:=colors[points[i,j]];
      Form1.PaintBox1.Canvas.Brush.Color:=colors[points[i,j]];
      Form1.PaintBox1.Canvas.Rectangle(c*(i-1),c*(j-1),c*i-1,c*j-1);
    end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
Form1.Caption:='W=' + IntToStr(Form1.Width) + ' H=' + IntToStr(Form1.Height);
end;

procedure TForm1.PaintBox1Click(Sender: TObject);
begin
Close;
end;

end.
